Index: src/sas/sasgui/perspectives/calculator/media/density_calculator_help.rst
===================================================================
--- src/sas/sasgui/perspectives/calculator/media/density_calculator_help.rst	(revision d85c194ea2f78cb2b9b3de9c969e1b8ebea6b6d2)
+++ src/sas/sasgui/perspectives/calculator/media/density_calculator_help.rst	(revision 6aad2e8b144e92be94b299c8ae7f4f418c094f1d)
@@ -29,5 +29,5 @@
 4) Click the 'Calculate' button to perform the calculation.
 
-.. image:: density_tutor.gif
+.. image:: density_tutor.png
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
Index: src/sas/sasgui/perspectives/calculator/media/gen_sas_help.html
===================================================================
--- src/sas/sasgui/perspectives/calculator/media/gen_sas_help.html	(revision d85c194ea2f78cb2b9b3de9c969e1b8ebea6b6d2)
+++ src/sas/sasgui/perspectives/calculator/media/gen_sas_help.html	(revision 6aad2e8b144e92be94b299c8ae7f4f418c094f1d)
@@ -19,5 +19,5 @@
 by the particle 
 <p>
-<img src="gen_i.gif"/>
+<img src="gen_i.png"/>
 </p>
 <br>
@@ -26,5 +26,5 @@
 of the j'th pixel respectively. And the total volume
 <p>
-<img src="v_j.gif"/>
+<img src="v_j.png"/>
 </p>
 <br>
@@ -44,10 +44,10 @@
 scattering length. (Figure below).
 <p>
-<img src="mag_vector.bmp"/>
+<img src="mag_vector.png"/>
 </p>
 <br>
 The magnetic scattering length density is then
 <p>
-<img src="dm_eq.gif"/>
+<img src="dm_eq.png"/>
 </p>
 <br>
@@ -66,5 +66,5 @@
 <br>
 <p>
-<img src="gen_mag_pic.bmp"/>
+<img src="gen_mag_pic.png"/>
 </p>
 <br>
@@ -75,5 +75,5 @@
 densities , including the nuclear scattering length density (&#946; <sub>N</sub>) are given as, for non-spin-flips,
 <p>
-<img src="sld1.gif"/>
+<img src="sld1.png"/>
 </p>
 <br>
@@ -81,5 +81,5 @@
 for spin-flips,
 <p>
-<img src="sld2.gif"/>
+<img src="sld2.png"/>
 </p>
 <br>
@@ -87,17 +87,17 @@
 where
 <p>
-<img src="mxp.gif"/>
+<img src="mxp.png"/>
 </p>
 <p>
-<img src="myp.gif"/>
+<img src="myp.png"/>
 </p>
 <p>
-<img src="mzp.gif"/>
+<img src="mzp.png"/>
 </p>
 <p>
-<img src="mqx.gif"/>
+<img src="mqx.png"/>
 </p>
 <p>
-<img src="mqy.gif"/>
+<img src="mqy.png"/>
 </p>
 <br>
@@ -110,5 +110,5 @@
 <br>
 <p>
-<img src="gen_gui_help.bmp"/>
+<img src="gen_gui_help.png"/>
 </p>
 <br>
@@ -136,5 +136,5 @@
 in a 2D output, whileas the scattering calculation averaged over all the orientations uses the Debye equation providing a 1D output:
  <p>
-<img src="gen_debye_eq.gif"/>
+<img src="gen_debye_eq.png"/>
 </p>
 <br>
Index: src/sas/sasgui/perspectives/calculator/media/image_viewer_help.rst
===================================================================
--- src/sas/sasgui/perspectives/calculator/media/image_viewer_help.rst	(revision da456fba6ab06ddec7ae847f352aff18d1d855d1)
+++ src/sas/sasgui/perspectives/calculator/media/image_viewer_help.rst	(revision 6aad2e8b144e92be94b299c8ae7f4f418c094f1d)
@@ -34,10 +34,10 @@
    will be displayed.
 
-.. image:: load_image.bmp
+.. image:: load_image.png
 
 3) To save, print, or copy the image, or to apply a grid overlay, right-click 
    anywhere in the plot.
 
-.. image:: pic_plot.bmp
+.. image:: pic_plot.png
 
 4. If the image is taken from a 2D detector, SasView can attempt to convert 
@@ -51,5 +51,5 @@
    then click the OK.
 
-.. image:: pic_convert.bmp
+.. image:: pic_convert.png
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
Index: src/sas/sasgui/perspectives/calculator/media/kiessig_calculator_help.rst
===================================================================
--- src/sas/sasgui/perspectives/calculator/media/kiessig_calculator_help.rst	(revision 780545820bf596bf3709c434f3eb26bcc29a1236)
+++ src/sas/sasgui/perspectives/calculator/media/kiessig_calculator_help.rst	(revision 5ed76f8390eac56ff5d3779fd9c454d0c8fe1dc0)
@@ -10,10 +10,15 @@
 -----------
 
-This tool is approximately estimates the thickness of a layer or the diameter 
-of particles from the position of the Kiessig fringe/Bragg peak in NR/SAS data 
-using the relation
+This tool estimates real space dimensions from the position or spacing of
+features in recipricol space.  In particular a particle of size $d$ will
+give rise to Bragg peaks with spacing $\Delta q$ according to the relation
 
-(thickness *or* size) = 2 * |pi| / (fringe_width *or* peak position)
-  
+.. math::
+
+    d = 2\pi / \Delta q
+
+Similarly, the spacing between the peaks in Kiessig fringes in reflectometry
+data arise from layers of thickness $d$.
+
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
 
@@ -21,9 +26,8 @@
 --------------
 
-To get a rough thickness or particle size, simply type the fringe or peak 
+To get a rough thickness or particle size, simply type the fringe or peak
 position (in units of 1/|Ang|\) and click on the *Compute* button.
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
 
-.. note::  This help document was last changed by Steve King, 01May2015
-
+.. note::  This help document was last changed by Paul Kienzle, 05Apr2017
Index: src/sas/sasgui/perspectives/calculator/media/resolution_calculator_help.rst
===================================================================
--- src/sas/sasgui/perspectives/calculator/media/resolution_calculator_help.rst	(revision 780545820bf596bf3709c434f3eb26bcc29a1236)
+++ src/sas/sasgui/perspectives/calculator/media/resolution_calculator_help.rst	(revision 5ed76f8390eac56ff5d3779fd9c454d0c8fe1dc0)
@@ -10,6 +10,6 @@
 -----------
 
-This tool is approximately estimates the resolution of Q from SAS instrumental 
-parameter values assuming that the detector is flat and normal to the 
+This tool is approximately estimates the resolution of $Q$ from SAS instrumental
+parameter values assuming that the detector is flat and normal to the
 incident beam.
 
@@ -23,47 +23,47 @@
 2) Select the source (Neutron or Photon) and source type (Monochromatic or TOF).
 
-   *NOTE! The computational difference between the sources is only the 
+   *NOTE! The computational difference between the sources is only the
    gravitational contribution due to the mass of the particles.*
 
-3) Change the default values of the instrumental parameters as required. Be 
+3) Change the default values of the instrumental parameters as required. Be
    careful to note that distances are specified in cm!
 
-4) Enter values for the source wavelength(s), |lambda|\ , and its spread (= FWHM/|lambda|\ ).
-   
-   For monochromatic sources, the inputs are just one value. For TOF sources, 
-   the minimum and maximum values should be separated by a '-' to specify a 
+4) Enter values for the source wavelength(s), $\lambda$, and its spread (= $\text{FWHM}/\lambda$).
+
+   For monochromatic sources, the inputs are just one value. For TOF sources,
+   the minimum and maximum values should be separated by a '-' to specify a
    range.
-   
-   Optionally, the wavelength (BUT NOT of the wavelength spread) can be extended 
-   by adding '; nn' where the 'nn' specifies the number of the bins for the 
-   numerical integration. The default value is nn = 10. The same number of bins 
+
+   Optionally, the wavelength (BUT NOT of the wavelength spread) can be extended
+   by adding '; nn' where the 'nn' specifies the number of the bins for the
+   numerical integration. The default value is nn = 10. The same number of bins
    will be used for the corresponding wavelength spread.
 
-5) For TOF, the default wavelength spectrum is flat. A custom spectral 
-   distribution file (2-column text: wavelength (|Ang|\) vs Intensity) can also 
+5) For TOF, the default wavelength spectrum is flat. A custom spectral
+   distribution file (2-column text: wavelength (|Ang|\) vs Intensity) can also
    be loaded by selecting *Add new* in the combo box.
 
-6) When ready, click the *Compute* button. Depending on the computation the 
+6) When ready, click the *Compute* button. Depending on the computation the
    calculation time will vary.
 
-7) 1D and 2D dQ values will be displayed at the bottom of the panel, and a 2D 
-   resolution weight distribution (a 2D elliptical Gaussian function) will also 
-   be displayed in the plot panel even if the Q inputs are outside of the 
+7) 1D and 2D $dQ$ values will be displayed at the bottom of the panel, and a 2D
+   resolution weight distribution (a 2D elliptical Gaussian function) will also
+   be displayed in the plot panel even if the $Q$ inputs are outside of the
    detector limit (the red lines indicate the limits of the detector).
-   
-   TOF only: green lines indicate the limits of the maximum Q range accessible 
+
+   TOF only: green lines indicate the limits of the maximum $Q$ range accessible
    for the longest wavelength due to the size of the detector.
-    
-   Note that the effect from the beam block/stop is ignored, so in the small Q 
-   region near the beam block/stop 
 
-   [ie., Q < 2. |pi|\ .(beam block diameter) / (sample-to-detector distance) / |lambda|\_min] 
+   Note that the effect from the beam block/stop is ignored, so in the small $Q$
+   region near the beam block/stop
+
+   [i.e., $Q < (2 \pi \cdot \text{beam block diameter}) / (\text{sample-to-detector distance} \cdot \lambda_\text{min})$]
 
    the variance is slightly under estimated.
 
-8) A summary of the calculation is written to the SasView *Console* at the 
+8) A summary of the calculation is written to the SasView *Console* at the
    bottom of the main SasView window.
 
-.. image:: resolution_tutor.gif
+.. image:: resolution_tutor.png
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
@@ -74,17 +74,17 @@
 The scattering wave transfer vector is by definition
 
-.. image:: q.gif
+.. image:: q.png
 
-In the small-angle limit, the variance of Q is to a first-order 
+In the small-angle limit, the variance of $Q$ is to a first-order
 approximation
 
-.. image:: sigma_q.gif
+.. image:: sigma_q.png
 
 The geometric and gravitational contributions can then be summarised as
 
-.. image:: sigma_table.gif
+.. image:: sigma_table.png
 
-Finally, a Gaussian function is used to describe the 2D weighting distribution 
-of the uncertainty in Q.
+Finally, a Gaussian function is used to describe the 2D weighting distribution
+of the uncertainty in $Q$.
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
@@ -93,8 +93,8 @@
 ----------
 
-D.F.R. Mildner and J.M. Carpenter 
+D.F.R. Mildner and J.M. Carpenter
 *J. Appl. Cryst.* 17 (1984) 249-256
 
-D.F.R. Mildner, J.M. Carpenter and D.L. Worcester 
+D.F.R. Mildner, J.M. Carpenter and D.L. Worcester
 *J. Appl. Cryst.* 19 (1986) 311-319
 
Index: src/sas/sasgui/perspectives/calculator/media/sas_calculator_help.rst
===================================================================
--- src/sas/sasgui/perspectives/calculator/media/sas_calculator_help.rst	(revision da456fba6ab06ddec7ae847f352aff18d1d855d1)
+++ src/sas/sasgui/perspectives/calculator/media/sas_calculator_help.rst	(revision 5ed76f8390eac56ff5d3779fd9c454d0c8fe1dc0)
@@ -19,34 +19,36 @@
 ------
 
-In general, a particle with a volume *V* can be described by an ensemble 
-containing *N* 3-dimensional rectangular pixels where each pixel is much 
-smaller than *V*.
+In general, a particle with a volume $V$ can be described by an ensemble
+containing $N$ 3-dimensional rectangular pixels where each pixel is much
+smaller than $V$.
 
-Assuming that all the pixel sizes are the same, the elastic scattering 
+Assuming that all the pixel sizes are the same, the elastic scattering
 intensity from the particle is
 
-.. image:: gen_i.gif
+.. image:: gen_i.png
 
 Equation 1.
 
-where |beta|\ :sub:`j` and *r*\ :sub:`j` are the scattering length density and 
-the position of the j'th pixel respectively.
+where $\beta_j$ and $r_j$ are the scattering length density and
+the position of the $j^\text{th}$ pixel respectively.
 
-The total volume *V*
+The total volume $V$
 
-.. image:: v_j.gif
+.. math::
 
-for |beta|\ :sub:`j` |noteql|\0 where *v*\ :sub:`j` is the volume of the j'th 
-pixel (or the j'th natural atomic volume (= atomic mass / (natural molar 
+    V = \sum_j^N v_j
+
+for $\beta_j \ne 0$ where $v_j$ is the volume of the $j^\text{th}$
+pixel (or the $j^\text{th}$ natural atomic volume (= atomic mass / (natural molar
 density * Avogadro number) for the atomic structures).
 
-*V* can be corrected by users. This correction is useful especially for an 
-atomic structure (such as taken from a PDB file) to get the right normalization. 
+$V$ can be corrected by users. This correction is useful especially for an
+atomic structure (such as taken from a PDB file) to get the right normalization.
 
-*NOTE!* |beta|\ :sub:`j` *displayed in the GUI may be incorrect but this will not 
+*NOTE! $\beta_j$ displayed in the GUI may be incorrect but this will not
 affect the scattering computation if the correction of the total volume V is made.*
 
-The scattering length density (SLD) of each pixel, where the SLD is uniform, is 
-a combination of the nuclear and magnetic SLDs and depends on the spin states 
+The scattering length density (SLD) of each pixel, where the SLD is uniform, is
+a combination of the nuclear and magnetic SLDs and depends on the spin states
 of the neutrons as follows.
 
@@ -54,57 +56,57 @@
 ^^^^^^^^^^^^^^^^^^^
 
-For magnetic scattering, only the magnetization component, *M*\ :sub:`perp`\ , 
-perpendicular to the scattering vector *Q* contributes to the magnetic 
+For magnetic scattering, only the magnetization component, $M_\perp$,
+perpendicular to the scattering vector $Q$ contributes to the magnetic
 scattering length.
 
-.. image:: mag_vector.bmp
+.. image:: mag_vector.png
 
 The magnetic scattering length density is then
 
-.. image:: dm_eq.gif
+.. image:: dm_eq.png
 
-where the gyromagnetic ratio |gamma| = -1.913, |mu|\ :sub:`B` is the Bohr 
-magneton, *r*\ :sub:`0` is the classical radius of electron, and |sigma| is the 
+where the gyromagnetic ratio is $\gamma = -1.913$, $\mu_B$ is the Bohr
+magneton, $r_0$ is the classical radius of electron, and $\sigma$ is the
 Pauli spin.
 
 For a polarized neutron, the magnetic scattering is depending on the spin states.
 
-Let us consider that the incident neutrons are polarised both parallel (+) and  
-anti-parallel (-) to the x' axis (see below). The possible states after 
-scattering from the sample are then 
+Let us consider that the incident neutrons are polarised both parallel (+) and
+anti-parallel (-) to the x' axis (see below). The possible states after
+scattering from the sample are then
 
 *  Non-spin flips: (+ +) and (- -)
 *  Spin flips:     (+ -) and (- +)
 
-.. image:: gen_mag_pic.bmp
+.. image:: gen_mag_pic.png
 
-Now let us assume that the angles of the *Q* vector and the spin-axis (x') 
-to the x-axis are |phi| and |theta|\ :sub:`up` respectively (see above). Then, 
-depending upon the polarization (spin) state of neutrons, the scattering 
-length densities, including the nuclear scattering length density (|beta|\ :sub:`N`\ ) 
+Now let us assume that the angles of the *Q* vector and the spin-axis (x')
+to the x-axis are $\phi$ and $\theta_\text{up}$ respectively (see above). Then,
+depending upon the polarization (spin) state of neutrons, the scattering
+length densities, including the nuclear scattering length density ($\beta_N$)
 are given as
 
 *  for non-spin-flips
 
-   .. image:: sld1.gif
+   .. image:: sld1.png
 
 *  for spin-flips
 
-   .. image:: sld2.gif
+   .. image:: sld2.png
 
 where
 
-.. image:: mxp.gif
+.. image:: mxp.png
 
-.. image:: myp.gif
+.. image:: myp.png
 
-.. image:: mzp.gif
+.. image:: mzp.png
 
-.. image:: mqx.gif
+.. image:: mqx.png
 
-.. image:: mqy.gif
+.. image:: mqy.png
 
-Here the *M0*\ :sub:`x`\ , *M0*\ :sub:`y` and *M0*\ :sub:`z` are the x, y and z 
-components of the magnetisation vector in the laboratory xyz frame. 
+Here the $M0_x$, $M0_y$ and $M0_z$ are the $x$, $y$ and $z$
+components of the magnetisation vector in the laboratory $xyz$ frame.
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
@@ -113,22 +115,22 @@
 --------------
 
-.. image:: gen_gui_help.bmp
+.. image:: gen_gui_help.png
 
-After computation the result will appear in the *Theory* box in the SasView  
+After computation the result will appear in the *Theory* box in the SasView
 *Data Explorer* panel.
 
-*Up_frac_in* and *Up_frac_out* are the ratio 
+*Up_frac_in* and *Up_frac_out* are the ratio
 
    (spin up) / (spin up + spin down)
-   
+
 of neutrons before the sample and at the analyzer, respectively.
 
-*NOTE 1. The values of* Up_frac_in *and* Up_frac_out *must be in the range 
+*NOTE 1. The values of* Up_frac_in *and* Up_frac_out *must be in the range
 0.0 to 1.0. Both values are 0.5 for unpolarized neutrons.*
 
-*NOTE 2. This computation is totally based on the pixel (or atomic) data fixed 
+*NOTE 2. This computation is totally based on the pixel (or atomic) data fixed
 in xyz coordinates. No angular orientational averaging is considered.*
 
-*NOTE 3. For the nuclear scattering length density, only the real component 
+*NOTE 3. For the nuclear scattering length density, only the real component
 is taken account.*
 
@@ -139,15 +141,15 @@
 
 The SANS Calculator tool can read some PDB, OMF or SLD files but ignores
-polarized/magnetic scattering when doing so, thus related parameters such as 
+polarized/magnetic scattering when doing so, thus related parameters such as
 *Up_frac_in*, etc, will be ignored.
 
-The calculation for fixed orientation uses Equation 1 above resulting in a 2D 
-output, whereas the scattering calculation averaged over all the orientations 
+The calculation for fixed orientation uses Equation 1 above resulting in a 2D
+output, whereas the scattering calculation averaged over all the orientations
 uses the Debye equation below providing a 1D output
 
-.. image:: gen_debye_eq.gif
+.. image:: gen_debye_eq.png
 
-where *v*\ :sub:`j` |beta|\ :sub:`j` |equiv| *b*\ :sub:`j` is the scattering 
-length of the j'th atom. The calculation output is passed to the *Data Explorer* 
+where $v_j \beta_j \equiv b_j$ is the scattering
+length of the $j^\text{th}$ atom. The calculation output is passed to the *Data Explorer*
 for further use.
 
Index: src/sas/sasgui/perspectives/calculator/media/sld_calculator_help.rst
===================================================================
--- src/sas/sasgui/perspectives/calculator/media/sld_calculator_help.rst	(revision f93b473fdbbdf1cc25efbb46c7adadea0e7d276d)
+++ src/sas/sasgui/perspectives/calculator/media/sld_calculator_help.rst	(revision 5ed76f8390eac56ff5d3779fd9c454d0c8fe1dc0)
@@ -10,10 +10,12 @@
 -----------
 
-The neutron scattering length density (SLD) is defined as
+The neutron scattering length density (SLD, $\beta_N$) is defined as
 
-  SLD = (b_c1 + b_c2 + ... + b_cn) / Vm
+.. math::
 
-where b_ci is the bound coherent scattering length of ith of n atoms in a molecule
-with the molecular volume Vm
+  \beta_N = (b_{c1} + b_{c2} + ... + b_{cn}) / V_m
+
+where $b_{ci}$ is the bound coherent scattering length of ith of n atoms in a molecule
+with the molecular volume $V_m$.
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
@@ -22,8 +24,8 @@
 ----------------------------
 
-To calculate scattering length densities enter the empirical formula of a 
+To calculate scattering length densities enter the empirical formula of a
 compound and its mass density and click "Calculate".
 
-Entering a wavelength value is optional (a default value of 6.0 |Ang| will 
+Entering a wavelength value is optional (a default value of 6.0 |Ang| will
 be used).
 
@@ -38,19 +40,19 @@
 *  Parentheses can be nested, such as "(CaCO3(H2O)6)1".
 
-*  Isotopes are represented by their atomic number in *square brackets*, such 
+*  Isotopes are represented by their atomic number in *square brackets*, such
    as "CaCO[18]3+6H2O", H[1], or H[2].
 
 *  Numbers of atoms can be integer or decimal, such as "CaCO3+(3HO0.5)2".
 
-*  The SLD of mixtures can be calculated as well. For example, for a 70-30 
+*  The SLD of mixtures can be calculated as well. For example, for a 70-30
    mixture of H2O/D2O write "H14O7+D6O3" or more simply "H7D3O5" (i.e. this says
    7 hydrogens, 3 deuteriums, and 5 oxygens) and enter a mass density calculated
    on the percentages of H2O and D2O.
 
-*  Type "C[13]6 H[2]12 O[18]6" for C(13)6H(2)12O(18)6 (6 Carbon-13 atoms, 12 
+*  Type "C[13]6 H[2]12 O[18]6" for C(13)6H(2)12O(18)6 (6 Carbon-13 atoms, 12
    deuterium atoms, and 6 Oxygen-18 atoms).
-   
+
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
 
-.. note::  This help document was last changed by Steve King, 01May2015
+.. note::  This help document was last changed by Paul Kienzle, 05Apr2017
 
Index: src/sas/sasgui/perspectives/calculator/media/slit_calculator_help.rst
===================================================================
--- src/sas/sasgui/perspectives/calculator/media/slit_calculator_help.rst	(revision f93b473fdbbdf1cc25efbb46c7adadea0e7d276d)
+++ src/sas/sasgui/perspectives/calculator/media/slit_calculator_help.rst	(revision 5ed76f8390eac56ff5d3779fd9c454d0c8fe1dc0)
@@ -11,10 +11,9 @@
 -----------
 
-This tool enables X-ray users to calculate the slit size (FWHM/2) for smearing 
+This tool enables X-ray users to calculate the slit size (FWHM/2) for smearing
 based on their half beam profile data.
 
 *NOTE! Whilst it may have some more generic applicability, the calculator has
-only been tested with beam profile data from Anton-Paar SAXSess*\ |TM|\  
-*software.*
+only been tested with beam profile data from Anton-Paar SAXSess:sup:`TM` software.*
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
@@ -27,11 +26,11 @@
 2) Load a beam profile file in the *Data* field using the *Browse* button.
 
-   *NOTE! To see an example of the beam profile file format, visit the file 
+   *NOTE! To see an example of the beam profile file format, visit the file
    beam profile.DAT in your {installation_directory}/SasView/test folder.*
 
-3) Once a data is loaded, the slit size is automatically computed and displayed 
+3) Once a data is loaded, the slit size is automatically computed and displayed
    in the tool window.
 
-*NOTE! The beam profile file does not carry any information about the units of 
+*NOTE! The beam profile file does not carry any information about the units of
 the Q data. This calculator assumes the data has units of 1/\ |Ang|\ . If the
 data is not in these units it must be manually converted beforehand.*